; A simple test for a 6502 assembler

.ORG $033C		; Can be *=$033C

FWDREF = TESTTAB+3

  JSR BYE		; Test forward ref
  LDY #0
LOOP:
  TYA			; Loop point..
  EOR ($FE),Y
PVDUHI= *+2
  STA $0400,Y
  INY
  BNE LOOP
  INC $FF
  DEC PVDUHI,X	; Self mod code, rotate VDU ptr hi.
  LDA PVDUHI
  ORA #4
  STA PVDUHI
  LDA 198		; Key hit?
  BEQ LOOP
BYE:
  RTS

.DEFINE EXTRA 1
.DEFINE EXTRA2 1

 
TAB2 = $03
  ADC TAB2,Y
  SBC FWDREF,Y		; Fwd ref to table..
  STX $80
  JMP ($1234)
 .IF EXTRA
   .IF EXTRA2		; Test nested .if/else..
      BRK  ; E1 E2
   .ELSE
      INX  ; E1 !E2
   .ENDIF

 .ELSE
   NOP		; Else..
   .IF EXTRA2
      TAY  ; !E1 E2
   .ELSE
      TYA  ; !E1 !E2
   .ENDIF
 .ENDIF

TESTTAB:
  .BYTE $2C, 255, 10 * 10, -1 + (1 << 4), <$FFD2+1
MYTEXT:
  .BYTE "THIS IS TEXT",13,10,0
  .WORD LOOP, 123*45, $FFD2
.END
